
#    Note:  This is loaded into the namespace  OPTION

# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag
     variable OptionSet

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

     do_click

     LoadOptions
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable ShowLogFlag 0

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable JS ""

    variable OptionSet "[first $::AIDA::ModuleMenu]"
    variable allmodules 0

   proc SaveOptions {} {
      variable TheseOptions
      variable OptionSet

      set NodeBase ::[set [set ::DataAcquisition::PROJECT]::DBNodeBase]
      set ::[set ::DataAcquisition::PROJECT]::DBNodeBase Options

      set Project $::DataAcquisition::PROJECT
      set NodeName [set ::[set Project]::DBNodeName]
      set ::[set Project]::DBNodeName $OptionSet

      set OptionList ""
      foreach item [array names TheseOptions] {
         if {$item == "Index"} {continue}
         if {[string length $OptionList] > 0} {append OptionList "&&"}
         append OptionList "$item"
         DBSetValue $item $TheseOptions($item)
      }
      DBSetValue Index $OptionList

      set ::[set ::DataAcquisition::PROJECT]::DBNodeBase $NodeBase
      set ::[set ::DataAcquisition::PROJECT]::DBNodeName $NodeName
   }

   proc LoadOptions {} {
      variable TheseOptions
      variable OptionSet

      set NodeBase ::[set ::[set ::DataAcquisition::PROJECT]::DBNodeBase]
      set ::[set ::DataAcquisition::PROJECT]::DBNodeBase Options

      set Project $::DataAcquisition::PROJECT
      set NodeName [set ::[set Project]::DBNodeName]
      set ::[set Project]::DBNodeName $OptionSet

      catch {unset TheseOptions}

      foreach item [split [DBGetValue Index] &&] {
         if {$item == "Index"} {continue}
         if {$item == ""} {continue}
         set TheseOptions($item) [DBGetValue $item]
      }

      set ::[set ::DataAcquisition::PROJECT]::DBNodeBase $NodeBase
      set ::[set ::DataAcquisition::PROJECT]::DBNodeName $NodeName
   }


   proc  show_variables {} {
       variable allmodules
       variable OptionSet
       variable TheseOptions

       LoadOptions

       InsertLog "Set = $OptionSet"
       InsertLog "all sets = $allmodules"

       set Project $::DataAcquisition::PROJECT
       InsertLog "Project $Project"
       InsertLog "DBRootName [set ::[set Project]::DBRootName]"
       InsertLog "DBNodeBase [set ::[set Project]::DBNodeBase]"
       InsertLog "DBNodeName [set ::[set Project]::DBNodeName]"

       InsertLog "Options: [array names TheseOptions]"

   }

   proc do_redisplay {} {}

   proc do_setOpt {index vl} {
      variable TheseOptions
      variable OptionSet
      variable allmodules

       set OptionName "undefined"
       set i 0
       foreach item [array names TheseOptions] {
          if {$item == "Index"} {continue}
          if {$i == $index} {set OptionName $item}
          incr i
       }

       if {$OptionName == "undefined"} {return}

       LoadOptions

       set TheseOptions($OptionName) $vl

       SaveOptions

      set BAK $OptionSet   ;#   save

      foreach item $::AIDA::ModuleMenu {
          if {$allmodules == 0 && $item != $BAK} continue

          set OptionSet $item

          LoadOptions
          set TheseOptions($OptionName) $vl
          SaveOptions

      }

      set $OptionSet $BAK   ;#   restore
      LoadOptions
   }

   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag
       variable OptionSet

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {

              set w [first [lindex $cgidata 1]]
              set vl [second [lindex $cgidata 1]]

               switch -glob $w {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                   MODULE     {set OptionSet $vl}
                   ALLMODULES {variable allmodules; set allmodules [expr ($allmodules + 1) & 1]}

                   OPTS     {do_setOpt [second [lindex $cgidata 1]] [third [lindex $cgidata 1]]}
                   EXPERT   {$vl}

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data:  $cgidata"}
               }
           }
        }
        do_redisplay
     }


}   ;# end of if {$started == 0}




